import { system, world, ItemStack  } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui";
import { 
    getScore, 
    getPlayerCountWithTag, 
    playSound, Tellraw, 
    ActionBar, setScore,
    removeTagsByPrefix, 
    getPlayerNamesWithTag, 
    ReplaceItemHotbar, 
    getHealthPercentage, 
    ReplaceItem,
    hasItemInInventory,
    incrementScore,
    modifyScore,
    getRandomInRange,
    cloceForm, runcmd_at, runcmd

} from '../other/utils';

export function dropBombExecute() {
    runcmd('execute as @e[type=item,name=bomb] at @s run event entity @e[type=fear:entites_bomb] fear:despawn', true);
    runcmd('execute as @e[type=item,name=bomb] at @s run summon fear:entites_bomb', true);
    runcmd('execute as @e[type=item,name=bomb] at @s run kill @s', true);
}

export function dropBomb(entity) {
}

export function giveBomb(player) {
    const name = player.name;

    if (player.hasTag("game:terrorist")) {
        Tellraw(player, "§a", "bomb.picked");
        ReplaceItemHotbar(player, "fear:bomb", 7, 1, false);

        runcmd_at(name, 'event entity @e[type=fear:entites_bomb] fear:despawn', true);
    } else {
        Tellraw(player, "§4", "bomb.cannot_pick");
    }
}


export function giveBombToRandomTerrorist() {
    const terrorists = world.getPlayers().filter(player => player.hasTag("game:terrorist"));

    const randomIndex = getRandomInRange(0, terrorists.length - 1);
    const selectedTerrorist = terrorists[randomIndex];

    try {
        ReplaceItemHotbar(selectedTerrorist, "fear:bomb", 7, 1, false);
        Tellraw(selectedTerrorist, "§a", "bomb.received");
        runcmd_at(selectedTerrorist.name, 'clear @s[hasitem={item=fear:bomb,quantity=2..}] fear:bomb 0 1', true);

        terrorists.forEach(player => {
            if (player !== selectedTerrorist) {
                Tellraw(player, `§6${selectedTerrorist.name} `, "bomb.got");
                runcmd_at(player.name, 'clear @s fear:bomb', true);
            }
        });
    } catch (error) {
    }
}


export function bombCondition() {
    const bombStatus = getScore("fear:settings", "bomb_condition", true);
    const bombAnimation = getScore("fear:settings", "bomb_animation", true);

    if (bombAnimation !== 0) return;

    if (bombStatus === 0) {
        runcmd(`playanimation @e[type=fear:entites_bomb] animation.cs_bomb.in_hand`);
    } else if (bombStatus === 1) {
        runcmd(`playanimation @e[type=fear:entites_bomb] animation.cs_bomb_move`);
    } else if (bombStatus === 2) {
        runcmd(`playanimation @e[type=fear:entites_bomb] animation.cs_bomb.defused`);
    }
}


