import { world } from "@minecraft/server";
import { handleHEGrenade } from "./he.js";
import { handleFlashGrenade } from "./flash.js";
import { handleFireGrenade } from "./fire.js";
import { handleSmokeGrenade } from "./smoke.js";

world.afterEvents.entitySpawn.subscribe(event => {
    const entity = event.entity;

    if (entity.typeId === "addon:he_grenade") {
        handleHEGrenade(entity);
    }

    if (entity.typeId === "addon:flash_grenade") {
        handleFlashGrenade(entity);
    }

    if (entity.typeId === "addon:fire_grenade") {
        handleFireGrenade(entity);
    }

    if (entity.typeId === "addon:smoke_grenade") {
        handleSmokeGrenade(entity);
    }
});




export function getPlayerTeam(player) {
    if (player.hasTag("game:terrorist")) return "terrorist";
    if (player.hasTag("game:commando")) return "commando";
    return "none";
}

export function getColoredName(playerName, team) {
    if (team === "terrorist") return `§c${playerName}§r`;
    if (team === "commando") return `§b${playerName}§r`; 
    return `§7${playerName}§r`; 
}

export function getPlayerByName(playerName) {
    for (let player of world.getAllPlayers()) {
        if (player.name === playerName) return player;
    }
    return null;
}

export function distance(pos1, pos2) {
    return Math.sqrt(
        Math.pow(pos1.x - pos2.x, 2) +
        Math.pow(pos1.y - pos2.y, 2) +
        Math.pow(pos1.z - pos2.z, 2)
    );
}
