
import { stopTimerSpecialForces } from "../game/special_forces_timer";
import { stopTimer } from "../game/purchaseTimer";
import { stopTimerExplode } from "../game/explodeTimer";
import { setScore, runcmd, Tellraw, getScore } from "../other/utils";
import { world, system } from "@minecraft/server";
import { toLobby } from "../lobby/to_lobby";
import { updateTagData } from "../other/tagUtils";

export function overGame(overGameStatus = 0) {
    textOverGame (overGameStatus)

    stopGameTimers()
    setScore("fear:settings", "bomb_animation", 0);
    setScore("fear:settings", "bomb_condition", 0);
    setScore("fear:settings", "restarter_map", 0);
    setScore("fear:settings", "lobby_timer", 0);
    setScore("fear:settings", "purchaseTimer", 0);
    setScore("fear:settings", "startTimerSpecialForces", 0);
    setScore("fear:settings", "startTimerExplode", 0);
    setScore("fear:settings", "roundsTakenTerrorist", 0);
    setScore("fear:settings", "roundsTakenCommando", 0);
    setScore("fear:settings", "loss_in_rowT", 0);
    setScore("fear:settings", "loss_in_rowCT", 0);
    setScore("fear:settings", "double_protection", 0);
    runcmd('gamerule naturalregeneration true', true);




    console.log("----------------- OVER GAME ----------------");
    setScore("fear:settings", "gameStatus", 0);
    
    const playersInGame = world.getPlayers().filter(player => player.hasTag("fear:game"));
    playersInGame.forEach(player => {
        toLobby(player)
    });

}


export function stopGameTimers() {

    stopTimerSpecialForces();
    stopTimer();
    stopTimerExplode();
}


function textOverGame (overGameStatus) {
    const playersInGame = world.getPlayers().filter(player => player.hasTag("fear:game"));
    const terrorists = playersInGame.filter(player => player.hasTag("game:terrorist") );
    const commando = playersInGame.filter(player => player.hasTag("game:commando") );

    const roundsTakenTerrorist = getScore("fear:settings", "roundsTakenTerrorist", true) || 0;
    const roundsTakenCommando = getScore("fear:settings", "roundsTakenCommando", true) || 0;


    playersInGame.forEach(player => {
        Tellraw(player, "§0");
        Tellraw(player, "======================================================");

        if (!player.hasTag(`game:terrorist`) && !player.hasTag(`game:commando`)) {
            if (roundsTakenTerrorist > roundsTakenCommando) {
                Tellraw(player, "§7", "fearcube.game.terrorists_win");
            } else {
                Tellraw(player, "§7", "fearcube.game.commandos_win");
            }
        }
    });


    
    terrorists.forEach(player => {
        if (overGameStatus === 0) {
            Tellraw(player, "§a", "fearcube.game.victory");
            Tellraw(player, "§7", "fearcube.game.enemy_left");
            updateTagData(player, "scores", 120, true);
        } else {
            if (roundsTakenTerrorist > roundsTakenCommando) {
                Tellraw(player, "§a", "fearcube.game.victory");
                updateTagData(player, "scores", 120, true);
            } else {
                Tellraw(player, "§c", "fearcube.game.defeat");
                updateTagData(player, "scores", 20, true);
            }
            Tellraw(player, `§7`, "fearcube.game.score", `: §f${roundsTakenTerrorist}§7 | §f${roundsTakenCommando}`);
        }
    
        const stats = terrorists.map(p => {
            const kills = getScore("fear:kill", p, true);
            const deaths = getScore("fear:deach", p, true);
            return `§f${p.name}§7 (§c${deaths} ${kills}§r)`;
        }).join("§7, ");
    
        Tellraw(player, `§8`, "fearcube.game.players", `: ${stats}`);
        updateTagData(player, "playGames", 1, true);
    });
    
    
    commando.forEach(player => {
        if (overGameStatus === 0) {
            Tellraw(player, "§a", "fearcube.game.victory");
            Tellraw(player, "§7", "fearcube.game.enemy_left");
            updateTagData(player, "scores", 120, true);
        } else {
            if (roundsTakenCommando > roundsTakenTerrorist) {
                Tellraw(player, "§a", "fearcube.game.victory");
                updateTagData(player, "scores", 120, true);
            } else {
                Tellraw(player, "§c", "fearcube.game.defeat");
                updateTagData(player, "scores", 20, true);
            }
            Tellraw(player, `§7`, "fearcube.game.score", `: §f${roundsTakenCommando}§7 | §f${roundsTakenTerrorist}`);
        }
    
        const stats = commando.map(p => {
            const kills = getScore("fear:kill", p, true);
            const deaths = getScore("fear:deach", p, true);
            return `§f${p.name}§7 (§c${deaths} ${kills}§r)`;
        }).join("§7, ");
    
        Tellraw(player, `§8`, "fearcube.game.players", `: ${stats}`);
        updateTagData(player, "playGames", 1, true);
    });
    
    
    playersInGame.forEach(player => {
        Tellraw(player, "======================================================");
        Tellraw(player, "§0");
    });


}