import { system, world } from '@minecraft/server';
import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui";

import { 
    getScore, 
    getPlayerCountWithTag, 
    playSound, Tellraw, 
    ActionBar, 
    removeTagsByPrefix, 
    getPlayerNamesWithTag, 
    ReplaceItemHotbar, 
    getHealthPercentage, 
    ReplaceItem,
    hasItemInInventory,
    incrementScore, runcmd_at, runcmd

} from '../other/utils';


export const shopItemsitemID = [   
    { 
        ID: "0",
        name: "netherite_chestplate",
        textRaising: "fearcube.item.armor.vest",

        itemID: "minecraft:netherite_chestplate",
        slot: "0",
        slotID: "slot.armor.chest",
        quantity: "1",
    },
    { 
        ID: "1",
        name: "netherite_helmet",
        textRaising: "fearcube.item.armor.vest_helmet",

        itemID: "minecraft:netherite_chestplate",
        slot: "0",
        slotID: "slot.armor.chest",
        quantity: "1",

        itemID1: "minecraft:netherite_helmet",
        slot1: "0",
        slotID1: "slot.armor.head",
        quantity1: "1"
    },
    { 
        ID: "2",
        name: "sapper_kit",
        textRaising: "fearcube.item.kit.defuse",

        itemID: "fear:sapper_kit",
        slot: "7",
        slotID: "slot.hotbar",
        quantity: "1"
    },




    { 
        ID: "3",
        name: "taurus",
        textRaising: "Taurus",

        itemID: "pistol:taurus",
        slot: "1",
        slotID: "slot.hotbar",
        quantity: "1",

        itemID1: "pistol:taurus_mag",
        slot1: "0",
        slotID1: "slot.inventory",
        quantity1: "64",

        alternative1: "pistol:taurus_empty",
        alternative2: "pistol:taurus_mag"
    },
    { 
        ID: "4",
        name: "p90",
        textRaising: "P90",
        itemID: "smg:p90",
        slot: "2",
        slotID: "slot.hotbar",
        quantity: "1",

        itemID1: "smg:p90_mag",
        slot1: "1",
        slotID1: "slot.inventory",
        quantity1: "64",

        alternative1: "smg:p90_empty",
        alternative2: "smg:p90_mag"
    },
    { 
        ID: "5",
        name: "mp5",
        textRaising: "MP5",
        itemID: "smg:mp5",
        slot: "2",
        slotID: "slot.hotbar",
        quantity: "1",

        itemID1: "smg:mp5_mag",
        slot1: "1",
        slotID1: "slot.inventory",
        quantity1: "64",

        alternative1: "smg:mp5_empty",
        alternative2: "smg:mp5_mag"
    },
    { 
        ID: "6",
        name: "akm",
        textRaising: "AKM",
        itemID: "ar:akm",
        slot: "2",
        slotID: "slot.hotbar",
        quantity: "1",

        itemID1: "ar:akm_mag",
        slot1: "1",
        slotID1: "slot.inventory",
        quantity1: "64",

        alternative1: "ar:akm_empty",
        alternative2: "ar:akm_mag"
    },
    { 
        ID: "7",
        name: "mk18",
        textRaising: "MK18",
        itemID: "ar:mk18",
        slot: "2",
        slotID: "slot.hotbar",
        quantity: "1",

        itemID1: "ar:mk18_mag",
        slot1: "1",
        slotID1: "slot.inventory",
        quantity1: "64",

        alternative1: "ar:mk18_empty",
        alternative2: "ar:mk18_mag"
    },
    { 
        ID: "8",
        name: "m3",
        textRaising: "M3 Shotgun",
        itemID: "shotgun:m3",
        slot: "2",
        slotID: "slot.hotbar",
        quantity: "1",

        itemID1: "shotgun:m3_ammo",
        slot1: "1",
        slotID1: "slot.inventory",
        quantity1: "64",

        alternative1: "shotgun:m3_empty",
        alternative2: "shotgun:m3_ammo"
    },
    { 
        ID: "9",
        name: "m249",
        textRaising: "M249",
        itemID: "lmg:m249",
        slot: "2",
        slotID: "slot.hotbar",
        quantity: "1",

        itemID1: "lmg:m249_mag",
        slot1: "1",
        slotID1: "slot.inventory",
        quantity1: "64",

        alternative1: "lmg:m249_empty",
        alternative2: "lmg:m249_mag"
    },
    { 
        ID: "10",
        name: "barrett",
        textRaising: "Barrett",
        itemID: "sniper:barrett",
        slot: "2",
        slotID: "slot.hotbar",
        quantity: "1",

        itemID1: "sniper:barrett_mag",
        slot1: "1",
        slotID1: "slot.inventory",
        quantity1: "64",

        alternative1: "sniper:barrett_empty",
        alternative2: "sniper:barrett_mag"
    },
    { 
        ID: "11",
        name: "awp",
        textRaising: "AWP",
        itemID: "sniper:awp",
        slot: "2",
        slotID: "slot.hotbar",
        quantity: "1",

        itemID1: "sniper:awp_mag",
        slot1: "1",
        slotID1: "slot.inventory",
        quantity1: "64",

        alternative1: "sniper:awp_empty",
        alternative2: "sniper:awp_mag"
    },
    { 
        ID: "12",
        name: "flash_grenade",
        textRaising: "fearcube.item.grenade.flash",
        itemID: "addon:flash_grenade",
        slot: "3",
        slotID: "slot.hotbar",
        quantity: "1"
    },
    { 
        ID: "13",
        name: "smoke_grenade",
        textRaising: "fearcube.item.grenade.smoke",
        itemID: "addon:smoke_grenade",
        slot: "4",
        slotID: "slot.hotbar",
        quantity: "1"
    },
    { 
        ID: "14",
        name: "he_grenade",
        textRaising: "fearcube.item.grenade.frag",
        itemID: "addon:he_grenade",
        slot: "5",
        slotID: "slot.hotbar",
        quantity: "1"
    },
    { 
        ID: "15",
        name: "fire_grenade",
        textRaising: "fearcube.item.grenade.incendiary",
        itemID: "addon:fire_grenade",
        slot: "6",
        slotID: "slot.hotbar",
        quantity: "1"
    }
    
];

function getItemInSlot(player, slotID, slot) {
    try {
        const inventory = player.getComponent("minecraft:inventory")?.container;
        if (!inventory) {
            return null;
        }

        const itemStack = inventory.getItem(parseInt(slot));
        return itemStack ? itemStack.typeId : null;
    } catch (error) {
        return null;
    }
}


export function setRaisingItems(player, name, nameEntity) {
    const itemConfig = shopItemsitemID.find(item => item.name === name);

    const currentSlotItem = getItemInSlot(player, itemConfig.slotID, itemConfig.slot);
    if (currentSlotItem) {
        const existingItemConfig = shopItemsitemID.find(item => 
            item.itemID === currentSlotItem || 
            item.alternative1 === currentSlotItem || 
            item.alternative2 === currentSlotItem
        );
        
        const existingItemName = existingItemConfig ? existingItemConfig.name : currentSlotItem;

        dropItems(player, existingItemName);
        runcmd_at(player.name, `event entity @e[tag="${nameEntity}",c=1] fear:despawn`, true);
    }

    ReplaceItem(
        player,
        itemConfig.itemID,
        itemConfig.slotID,
        itemConfig.slot,
        parseInt(itemConfig.quantity || 1),
        true
    );
    runcmd_at(player.name, `event entity @e[tag="${nameEntity}",c=1] fear:despawn`, true);

    if (itemConfig.itemID1 && itemConfig.slot1 !== undefined) {
        ReplaceItem(
            player,
            itemConfig.itemID1,
            itemConfig.slotID1,
            itemConfig.slot1,
            parseInt(itemConfig.quantity1 || 1),
            true
        );
    }

    const textRaising = itemConfig.textRaising || "Неизвестный предмет";
    Tellraw(player, "§7=> ", "fearcube.item.you.picked", "§a ", textRaising);
    playSound(player, "fear.taking_up_arms", 1, 1);
}



export function raisingItems(player, name) {

    const hasBomb = hasItemInInventory(player, "fear:bomb", 1);



    const bombStatus = getScore("fear:settings", "bomb_condition", true); 
    if (bombStatus === 0) {
        if (name === "bomb") {
            if (!hasBomb) {
                ReplaceItemHotbar(player, "fear:bomb", 7, 1, false);
                Tellraw(player, "§7=> ", "fearcube.item.picked", "§c ", "item.fear:bomb");
                playSound(player, "fear.taking_up_arms", 1, 1);
                runcmd_at(player.name, `event entity @e[type=fear:entites_bomb] fear:despawn`, true);
                return;
            }
        }
            
    } 

    

    const itemConfig = shopItemsitemID.find(item => item.name === name);
    if (!itemConfig) {
        return;
    }

    const inventory = player.getComponent("minecraft:inventory")?.container;
    const mainSlotIndex = parseInt(itemConfig.slot);
    const mainSlotItem = inventory.getItem(mainSlotIndex);

    if (mainSlotItem) {
        return;
    }

    ReplaceItem(
        player,
        itemConfig.itemID,
        itemConfig.slotID,
        mainSlotIndex,
        parseInt(itemConfig.quantity || 1),
        true
    );
    runcmd_at(player.name, `event entity @e[type=fear:${name},c=1] fear:despawn`, true);

    if (itemConfig.itemID1) {
        const additionalSlotIndex = parseInt(itemConfig.slot1);
        if (!isNaN(additionalSlotIndex)) {
            ReplaceItem(
                player,
                itemConfig.itemID1,
                itemConfig.slotID1,
                additionalSlotIndex,
                parseInt(itemConfig.quantity1 || 1),
                true
            );
        }
    }

    const textRaising = itemConfig.textRaising || "Неизвестный предмет";
    Tellraw(player, "§7=> ", "fearcube.item.picked", "§a ", textRaising);
    playSound(player, "fear.taking_up_arms", 1, 1);
}





export function teleportEntityWithBounce(entity, height = 3, distance = 2, scatter = 0.3, playerName, dropID) {
    try {
        const player = world.getPlayers().find(p => p.name === playerName);
        if (!player) return;

        const { x: px, y: py, z: pz } = player.location;
        const entityPos = entity.location;
        if (!entityPos) return;

        const directionX = entityPos.x - px;
        const directionY = entityPos.y - py;
        const directionZ = entityPos.z - pz;

        const magnitude = Math.sqrt(directionX ** 2 + directionY ** 2 + directionZ ** 2) || 1;

        const normalizedDirection = {
            x: directionX / magnitude + (Math.random() - 0.5) * scatter,
            y: directionY / magnitude + height,
            z: directionZ / magnitude + (Math.random() - 0.5) * scatter
        };

        let targetX = entityPos.x + normalizedDirection.x * distance;
        let targetY = entityPos.y + normalizedDirection.y;
        let targetZ = entityPos.z + normalizedDirection.z * distance;

        const block = world.getDimension("overworld").getBlock({ x: Math.floor(targetX), y: Math.floor(targetY), z: Math.floor(targetZ) });

        if (block && block.typeId !== "minecraft:air") {
            targetX = (entityPos.x + px) / 2;
            targetZ = (entityPos.z + pz) / 2;
            targetY = entityPos.y + 1.2;
        }

        const dim = world.getDimension("overworld");
        dim.runCommand(`execute as @e[tag="DropItemID:${dropID}",c=1] at @s run tag @s add "fear:dropItems"`);
        dim.runCommand(`execute as @e[tag="DropItemID:${dropID}",c=1] at @s run tp @s ${targetX.toFixed(2)} ${targetY.toFixed(2)} ${targetZ.toFixed(2)}`);

        system.runTimeout(() => {
            dim.runCommand(`execute as @e[tag="DropItemID:${dropID}",c=1] at @s run playsound fear.weapon_drop @a ~~~ 0.3 1`);
        }, 10);

    } catch (error) {
        console.warn("Ошибка в teleportEntityWithBounce:", error);
    }
}











system.afterEvents.scriptEventReceive.subscribe((event) => {
    const entity = event.sourceEntity;

    if (event.id === "fear:dropItem_setNamePlayer") {
        const playerName = event.message.replace(/"/g, '');

        const dropTag = entity.getTags().find(tag => tag.startsWith("DropItemID:"));
        const dropID = dropTag.split(":")[1];

        const height = 1; 
        const distance = 2.5;
        const scatter = 0.5;

        teleportEntityWithBounce(entity, height, distance, scatter, playerName, dropID);
    }

    if (event.id === "fear:setTagIdDropItems") {
        const newScore = incrementScore('fear:settings', 'DropItemID', 1);

        entity.addTag(`DropItemID:${newScore}`);
    }
    
});






export function dropItems(player, name) {
    runcmd_at(player.name, `summon fear:${name} ^^1^0.1 facing @p fear:setIdTag`, true);
    system.runTimeout(() => {
        runcmd_at(player.name, `execute as @e[type=fear:${name},c=1] at @s run scriptevent fear:dropItem_setNamePlayer "${player.name}"`, true);
    }, 1);

}


