import { world } from "@minecraft/server";
import { getScore, ReplaceItemHotbar, runcmd_at, ReplaceItem } from '../other/utils';

world.afterEvents.playerSpawn.subscribe(event => {
    const purchaseTimer = getScore('fear:settings', 'purchaseTimer', true);
    const player = event.player;

    if (!event.initialSpawn) {
        if (player.hasTag(`fear:game`)) {
            if (purchaseTimer === 0) {
                runcmd_at(player.name, `inputpermission set @s movement enabled`, true);
                ReplaceItemHotbar(player, "addon:combat_knife", 0, 1, true);
                ReplaceItem(player, "pistol:taurus", "slot.hotbar", 1, 1, true);
                ReplaceItem(player, "pistol:taurus_mag", "slot.inventory", 0, 64, true);

            } else {
                runcmd_at(player.name, `inputpermission set @s movement disabled`, true);
                ReplaceItemHotbar(player, "addon:combat_knife", 0, 1, true);
                ReplaceItemHotbar(player, "fear:shoop", 8, 1, true);
                ReplaceItem(player, "pistol:taurus", "slot.hotbar", 1, 1, true);
                ReplaceItem(player, "pistol:taurus_mag", "slot.inventory", 0, 64, true);
            }
        }
    } 
});

