import { system, world, ItemStack  } from "@minecraft/server";
import { UIupdateGame } from '../ui/globalGame';
import { startTimer } from '../game/purchaseTimer';
import { teleportPlayers } from '../game/distribution';
import { checkVictoryConditions, handleVictory } from '../game/vinerRaund';
import { dropBombExecute, bombCondition } from '../game/bomb';
import { teleportHeadsToPlayers } from '../game/customHead';
import { setAnimationsPlant } from '../game/startGame';
import { hasItemInHand, ckeckItemInHand} from '../game/itemsInHand';
import { 
    getScore, 
    getPlayerCountWithTag, 
    playSound, Tellraw, 
    ActionBar, 
    removeTagsByPrefix, 
    getPlayerNamesWithTag, 
    ReplaceItemHotbar, 
    getHealthPercentage, 
    ReplaceItem,
    hasItemInInventory,
    incrementScore,
    modifyScore,
    getRandomInRange,
    cloceForm, runcmd,
    setScore, runcmd_at

} from '../other/utils';




let activeInterval = null;

export function startTimerSpecialForces() {
    if (activeInterval) {
        console.warn("startTimerSpecialForces уже запущен, повторный запуск отменён");
        return; 
    }
    const playersInGame = world.getPlayers().filter(player => player.hasTag("fear:game"));

    

    const startTimerSpecialForces = getScore('fear:settings', 'startTimerSpecialForces', true);
    if (startTimerSpecialForces === 0) {
        setScore("fear:settings", "startTimerSpecialForces", 115);
    }
    
    setScore("fear:settings", "restarter_map", 3);

    let remaining = getScore('fear:settings', 'startTimerSpecialForces', true);
    if (remaining !== null && remaining > 0 && activeInterval !== null) {
        return; 
    }
    activeInterval = system.runInterval(() => {
        teleportHeadsToPlayers()
    }, 1);
    
    activeInterval = system.runInterval(() => {
        setAnimationsPlant();
    }, 100);

    
    activeInterval = system.runInterval(() => {
        remaining = getScore('fear:settings', 'startTimerSpecialForces', true);

        if (remaining > 1) {
            UIupdateGame()
            bombCondition()
            checkVictoryConditions()
            dropBombExecute()
            modifyScore("fear:settings", `startTimerSpecialForces`, -1);
        } else {
            const restarter_map = getScore('fear:settings', 'restarter_map', true);
            if (restarter_map === 3) {
                handleVictory("commando", playersInGame);
                const counterTerrorists = world.getPlayers().filter(p => p.hasTag("game:commando"));
                counterTerrorists.forEach(ct => {
                    modifyScore("fear:balance", ct.name, 3250);
                    Tellraw(ct, "+$3250 §a", "reward.time_victory");
                });


                system.runTimeout(() => {
                    setScore("fear:settings", "purchaseTimer", 20);
                    startTimer(); 
                }, 150);
                runcmd('event entity @e[family=cs_drop] fear:despawn', true);
                system.runTimeout(() => {
                    teleportPlayers();
                }, 145);
                stopTimerSpecialForces();
                setScore("fear:settings", "bomb_protection", 1);
                
            }

  
            
        }
        playersInGame.forEach(player => {
            ckeckItemInHand(player)
            .then(() => {
                const foundItem = hasItemInHand(player);
                if ((foundItem === "addon:combat_knife")) {
                    runcmd_at(player.name, `event entity @s normal:player`, true);
                }
            })
        });
    }, 20);


}

export function stopTimerSpecialForces() {
    setScore("fear:settings", "startTimerSpecialForces", 0);
    if (activeInterval !== null) {
        system.clearRun(activeInterval);
        activeInterval = null;
    }
}
