import { assignCommandoTags, assignTerroristTags, teleportPlayers, exchangeLobbyTag, spawnpointPlayers } from '../game/distribution';
import { startTimer } from '../game/purchaseTimer';
import { setScore, runcmd } from '../other/utils';
import { world, system } from '@minecraft/server';

function setGameID() {
    return runcmd(`scoreboard players add gameID fear:settings 1`, true);
}

export function startGame() {
    console.log("----------------- START GAME ----------------");
    setScore("fear:settings", "gameStatus", 1);

    setGameID();
        runcmd('gamerule naturalregeneration false', true);
        runcmd('scoreboard players reset * fear:deach', true);
        runcmd('scoreboard players reset * fear:kill', true);
        runcmd('scoreboard players set @a fear:deach 0', true);
        runcmd('scoreboard players set @a fear:kill 0', true);
        runcmd('scoreboard players set loss_in_rowT fear:settings 1', true);
        runcmd('scoreboard players set loss_in_rowCT fear:settings 1', true);

    system.runTimeout(() => {
        setScore("fear:settings", "purchaseTimer", 20);
        exchangeLobbyTag(); 
        startTimer()

        system.runTimeout(() => {
            assignTerroristTags();

            system.runTimeout(() => {
                assignCommandoTags();

                system.runTimeout(() => {
                    teleportPlayers();
                    setAnimationsPlant();

                    system.runTimeout(() => {
                        spawnpointPlayers();
                    }, 1);
                }, 1);
            }, 1);
        }, 1);
    }, 1);
}

export function setAnimationsPlant() {
    runcmd(`execute as @e[type=fear:directly_plant,name=arrow_l] at @s run playanimation @s animation.directly_plant.arrow_l`, true);
    runcmd(`execute as @e[type=fear:directly_plant,name=arrow_r] at @s run playanimation @s animation.directly_plant.arrow_r`, true);
    runcmd(`execute as @e[type=fear:directly_plant,name=arrow_top] at @s run playanimation @s animation.directly_plant.arrow_top`, true);
    runcmd(`execute as @e[type=fear:directly_plant,name=aroow_down] at @s run playanimation @s animation.directly_plant.aroow_down`, true);
    runcmd(`execute as @e[type=fear:directly_plant,name=floor_1x] at @s run playanimation @s animation.directly_plant.floor_1x`, true);
    runcmd(`execute as @e[type=fear:directly_plant,name=floor_3x] at @s run playanimation @s animation.directly_plant.floor_3x`, true);
}