import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui";
import { system, world } from '@minecraft/server';

export function informationMain(player) {
    let form = new ActionFormData();
    form.title("%fearcube.information.projects");

    form.button(`PixelPoly`, "textures/fearcube/map_information/PixelPoly/logo");
    form.button(`§l§0Fear§4Cube`, "textures/fearcube/map_information/FearCube/logo");
    form.button(`InSaRe`, "textures/fearcube/map_information/InSaRe/logo");

    system.run(() => {
        form.show(player).then(r => {
            if (r.canceled) return;
        
            let response = r.selection;
            switch (response) {
                case 0:
                    informationPixelPolyMain(player);
                break;
                case 1:
                    informationFearCube(player);
                break;
                case 2:
                    informationInSaReMain(player);
                break;
                default:
            }
        }).catch(e => {
            console.error(e, e.stack);
        });
    });

}


function informationFearCube(player) {
    let form = new ActionFormData();
    form.title("%fearcube.information.about_project");

    form.button(`Miste..`, "textures/fearcube/map_information/FearCube/MisterFear2023");
    form.button(`Rusla..`, "textures/fearcube/map_information/FearCube/Ruslan_IV2088");
    form.button(`Happy..`, "textures/fearcube/map_information/FearCube/HappyKartor");
    form.button(`Progect`, "textures/fearcube/map_information/FearCube/logo");
    form.button(`Dark5..`, "textures/fearcube/map_information/FearCube/Dark5945");
    form.button(`FearF..`, "textures/fearcube/map_information/FearCube/FearFulSpit");

    system.run(() => {
        form.show(player).then(r => {
            if (r.canceled) return;
        
            let response = r.selection;
            switch (response) {
                case 0:
                    informationFearCubeMisterFear2023(player);
                break;

                case 1:
                    informationFearCubeRuslan_IV2088(player);
                break;

                case 2:
                    informationFearCubeHappyKartor(player);
                break;

                case 3:
                    informationFearCubeMain(player);
                break;

                case 4:
                    informationFearCubeDrak5945(player);
                break;

                case 5:
                    informationFearCubeFearFulSpitr(player);
                break;
                
                default:
            }
        }).catch(e => {
            console.error(e, e.stack);
        });
    });

}


function informationFearCubeMisterFear2023(player) {
    let form = new ModalFormData()
        form.title("%fearcube.information.creator_title - MisterFear2023");

        form.textField(
            "\n                §cMisterFear2023§7 \n\n%fearcube.information.creator_desc §o§bhttps://t.me/vs59_2§r§7\n\n Telegram", 
            "§o§bhttps://t.me/vs59_2", 
            { defaultValue: "§o§bhttps://t.me/vs59_2" }
        );


    form.show(player).then(r => {
    }).catch(e => {
        console.error(e, e.stack);
    });
}

function informationFearCubeRuslan_IV2088(player) {
    let form = new ModalFormData()
        form.title("%fearcube.information.builder_title - Ruslan_IV2088");

        form.textField("\n                  §cRuslan_IV2088§7 \n\n%fearcube.information.builder_desc \n\n Telegram", "§o§chttps://t.me/Ruslan_IV_1",{defaultValue: "§o§chttps://t.me/Ruslan_IV_1"})
        form.textField(" YouTube", "§o§ahttps://youtube.com/@ruslan_iv?si=IRHJyU7mUOEuVwDN",{defaultValue: "§o§chttps://youtube.com/@ruslan_iv?si=IRHJyU7mUOEuVwDN"})
        form.textField(" Discord", "§o§a@ruslan_iv",{defaultValue: "§o§c@ruslan_iv"})
        form.textField(" VK", "§o§ahttps://vk.com/id542773938",{defaultValue: "§o§chttps://vk.com/id542773938"})
        form.textField(" Instagram", "§o§ahttps://www.instagram.com/ryusui_iv?igsh=MWd6aXk3NzFnOHE5Nw==",{defaultValue: "§o§chttps://www.instagram.com/ryusui_iv?igsh=MWd6aXk3NzFnOHE5Nw=="})

    form.show(player).then(r => {
    }).catch(e => {
        console.error(e, e.stack);
    });
}

function informationFearCubeDrak5945(player) {
    let form = new ModalFormData()
        form.title("%fearcube.information.report_manager - Drak5945");

        form.textField("\n                    §cDrak5945§7 \n\n%fearcube.information.report_manager_inf \n\n Telegram", "§o§chttps://t.me/sur5hard",{defaultValue: "§o§chttps://t.me/sur5hard"})


    form.show(player).then(r => {
    }).catch(e => {
        console.error(e, e.stack);
    });
}



function informationFearCubeHappyKartor(player) {
    let form = new ModalFormData()
        form.title("%fearcube.information.web_dev_title - HappyKartor");

        form.textField("\n                   §cHappyKartor§7 \n\n%fearcube.information.web_dev_desc \n\n Telegram", "§o§chttps://t.me/spvp54", {defaultValue:"§o§chttps://t.me/spvp54"})


    form.show(player).then(r => {
    }).catch(e => {
        console.error(e, e.stack);
    });
}


function informationFearCubeFearFulSpitr(player) {
    let form = new ModalFormData()
        form.title("%fearcube.information.content_manager_title - FearFulSpit");

        form.textField("\n                   §cFearFulSpit§7 \n\n%fearcube.information.content_manager_desc \n\n Telegram", "§o§chttps://t.me/FearFulSpit",{defaultValue: "§o§chttps://t.me/FearFulSpit"})


    form.show(player).then(r => {
    }).catch(e => {
        console.error(e, e.stack);
    });
}



function informationFearCubeMain(player) {
    let form = new ModalFormData()
        form.title("FearCube");

        form.textField("\n                   §7 \n\n%fearcube.information.description §r\n\n%fearcube.information.follow_updates \n\n%fearcube.information.telegram_info \n\n", "§o§bhttps://www.fearcube.com/",{defaultValue: "§o§bhttps://www.fearcube.com/"})


    form.show(player).then(r => {
    }).catch(e => {
        console.error(e, e.stack);
    });
}


function informationInSaReMain(player) {

    let form = new ModalFormData()
        form.title("InSaRe");
        form.textField("%fearcube.information.weapon_creator_desc \n\n YouTube", "§o§ahttps://www.youtube.com/@-insare-1271", {defaultValue:"§o§ahttps://www.youtube.com/@-insare-1271"})
        form.textField(" Telegram", "§o§ahttps://t.me/InSaRehome", {defaultValue:"§o§ahttps://t.me/InSaRehome"})
        form.textField(" Discord server", "§o§ahttps://discord.gg/CvwVMVXBEC", {defaultValue:"§o§ahttps://discord.gg/CvwVMVXBEC"})
        form.textField(" VK group", "§o§ahttps://vk.com/insareofficial", {defaultValue:"§o§ahttps://vk.com/insareofficial"})
        form.textField(" Rutube", "§o§ahttps://rutube.ru/channel/38756216/about/", {defaultValue:"§o§ahttps://rutube.ru/channel/38756216/about/"})
        form.textField(" Yandex Dzen", "§o§ahttps://dzen.ru/id/66a6a3450bb3253929bdceaf", {defaultValue:"§o§ahttps://dzen.ru/id/66a6a3450bb3253929bdceaf"})

    form.show(player).then(r => {
    }).catch(e => {
        console.error(e, e.stack);
    });
}



function informationPixelPolyMain(player) {

    let form = new ModalFormData()
        form.title("PixelPoly");
        form.textField("\n              PixelPoly Digital \n\n%fearcube.information.pixelpoly_desc \n\n%fearcube.information.resourcepack_notice_desc  \n\n", "§o§ahttps://pixelpoly.co/", {defaultValue:"§o§ahttps://pixelpoly.co/"})

    form.show(player).then(r => {
    }).catch(e => {
        console.error(e, e.stack);
    });
}