import { system, world } from '@minecraft/server';
import { ActionFormData } from "@minecraft/server-ui";
import { getPlayerCountWithTag, playSound, Tellraw, ActionBar, removeTagsByPrefix } from '../other/utils';
import { UiLobby } from "../ui/glogalLobby";
import { startLobby } from '../lobby/timer';

export function formSelectTeam(player) {
    playSound(player, "fear.selectteam", 0.1, 1);
    let form = new ActionFormData();
    form.title("%fearcube.form.selectteam");
    form.button(`%fearcube.team.terrorists.plural`, "textures/fearcube/icon/terrorist");
    form.button(`%fearcube.team.specialforces.plural`, "textures/fearcube/icon/commando");

    form.show(player).then(r => {
        if (r.canceled) return;

        let response = r.selection;
        switch (response) {
            case 0:
                if (player.hasTag(`lobby:terrorist`)) {
                    Tellraw(player, "§4", "fearcube.team.side.already");
                    playSound(player, "block.lantern.place", 1, 0.8);
                } 
                else {
                    removeTagsByPrefix(player, "lobby:")
                    player.addTag('lobby:terrorist');
                    Tellraw(player, "§7", "fearcube.team.side.chosen"," §m","fearcube.team.terrorists");
                    playSound(player, "block.lantern.place", 1, 0.3);
                }

                
                break;
            case 1:
                if (player.hasTag(`lobby:commando`)) {
                    Tellraw(player, "§4", "fearcube.team.side.already");
                    playSound(player, "block.lantern.place", 1, 0.8);
                    
                } 
                else {
                    removeTagsByPrefix(player, "lobby:")
                    player.addTag('lobby:commando');
                    Tellraw(player, "§7", "fearcube.team.side.chosen"," §b","fearcube.team.specialforces");
                    playSound(player, "block.lantern.place", 1, 0.3);
                }
                
                break;
            default:
        }
    }).catch(e => {
    }).finally(() => {
        
        
        UiLobby()
        startLobby()
        
    });
}
