import './ui/ShoopMain.js';

import './lobby/timer.js';
import './lobby/to_lobby.js';
import './game/index.js';
import './lobby/index.js';

import './test.js';
import './game/grenade/index.js';
import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui";

import { world, system, Player, EntityHealthComponent, EntityComponentTypes  } from "@minecraft/server";
import { handleBlockInteraction } from "./other/eventHandler";
import { handleEntityInteraction } from "./other/entityInteractionHandler.js";
import { handleEntityHurt } from "./other/entityHurtHandler.js";
import { handlePlayerJoin, PlayerJoin } from "./other/playerJoinHandler.js";
import { UIglobalLobby, UItopCenterLobby } from "./ui/glogalLobby.js";
import { handleItemUse } from './other/itemUseHandler.js';
import { formSelectTeam } from "./lobby/form";
import { RemoveAllTags, toLobby, setLobby } from "./lobby/to_lobby.js";
import { raisingItems } from "./game/raisingItems.js";
import { deachPlayer } from "./game/deachPlayer.js";
import { ShopGameMain } from './ui/ShoopMain';
import { handleEntityDie } from './other/playerHandlers.js';



// scriptevent
import {  dropBomb } from './game/bomb';


// времено
import { overGame } from './game/overGame.js';


import { handleChatMessage } from "./other/chatLogic.js";

world.beforeEvents.chatSend.subscribe((event) => {handleChatMessage(event);});
world.beforeEvents.itemUse.subscribe(handleItemUse);
world.beforeEvents.playerInteractWithBlock.subscribe(handleBlockInteraction);
world.beforeEvents.playerInteractWithEntity.subscribe(handleEntityInteraction);
world.afterEvents.entityHurt.subscribe(handleEntityHurt);
world.afterEvents.playerJoin.subscribe(handlePlayerJoin);
world.afterEvents.entityDie.subscribe(handleEntityDie);


system.afterEvents.scriptEventReceive.subscribe((event) => {
    const player = event.sourceEntity;


    if (event.id === "fearcube:setLobby") { setLobby(player); }

    if (event.id === "fearcube:lobbyUI") {
        UItopCenterLobby(player);
        system.runTimeout(() => {
            UIglobalLobby(player);
        }, 1);
    }

    if (event.id === "fearcube:formSelectTeam") {
        formSelectTeam(player);
    }

    if (event.id === "fear:dropBomb") {
        dropBomb(player, 3, 1.5, 0.3);
    }

    if (event.id === "fearcube:item_drop") {
        const name = event.message; 
        if (!name || typeof name !== "string") {
            console.error(`Неверное значение event.message: ${event.message}`);
            return;
        }
        raisingItems(player, name); 
    }
    
    if (event.id === "fear:test_tpLobby") { toLobby(player); overGame();}
    if (event.id === "fear:deachPlayer") { deachPlayer(player);}
    if (event.id === "fearcube:shopMain") { ShopGameMain(player)}
    if (event.id === "test:form") { 
                    let form = new ActionFormData();
            form.title(`STATS`);
            form.body(`§l %fearcube.cs.over_stats.game: `);
            form.button(`OK`);   
            
            
            form.show(player).then(r => {
                if (r.canceled) return;
                let response = r.selection;
                switch (response) {
                    case 0: 
                        break;
                    default:
                }
            }).catch(e => {
                console.error(e, e.stack);
            });
    }

    // if (event.id === "fear:test") { UIupdateGame(player);}
});


import { restarterMap } from './restarterMap.js';
system.run(() => {
    restarterMap()
});


