
import { system, world } from '@minecraft/server';
import {getScore, runcmd_at, runcmd, ReplaceItem, cloceUI, removeTagsByPrefix, Tellraw, playSound} from '../other/utils'
import { playerWatch } from '../lobby/to_lobby'
import { informationMain } from '../informationMap'
import { toLobby } from '../lobby/to_lobby'

export function handleItemUse(event) {
    const player = event.source;
    const name = player.name;
    const purchaseTimer = getScore('fear:settings', 'purchaseTimer', true);
    const typeId = event.itemStack.typeId;

    if (typeId === "fear:selectteam") {
        runcmd_at(name, `scriptevent fearcube:formSelectTeam`, true);
        return;
    }

    if (typeId === "fear:shoop") {
        runcmd_at(name, `scriptevent fearcube:shopMain`, true);
        return;
    }

    if (typeId === "addon:he_grenade" && purchaseTimer === 0) {
        runcmd_at(name, `event entity @s fear:cs_he_grenade`, true);
        runcmd_at(name, `clear @s addon:he_grenade`, true);
        return;
    }

    if (typeId === "addon:flash_grenade" && purchaseTimer === 0) {
        runcmd_at(name, `event entity @s fear:cs_flash_grenade`, true);
        runcmd_at(name, `clear @s addon:flash_grenade`, true);
        return;
    }

    if (typeId === "addon:fire_grenade" && purchaseTimer === 0) {
        runcmd_at(name, `event entity @s fear:cs_fire_grenade`, true);
        runcmd_at(name, `clear @s addon:fire_grenade`, true);
        return;
    }

    if (typeId === "addon:smoke_grenade" && purchaseTimer === 0) {
        runcmd_at(name, `event entity @s fear:cs_smoke_grenade`, true);
        runcmd_at(name, `clear @s addon:smoke_grenade`, true);
        return;
    }

    if (typeId === "smg:p90_empty") {
        ReplaceItem(player, "smg:p90_mag", "slot.hotbar", 2, 1, true);
        return;
    }
    if (typeId === "smg:mp5_empty") {
        ReplaceItem(player, "smg:mp5_mag", "slot.hotbar", 2, 1, true);
        return;
    }
    if (typeId === "shotgun:m3_empty") {
        ReplaceItem(player, "shotgun:m3_ammo", "slot.hotbar", 2, 1, true);
        return;
    }
    if (typeId === "fear:back") {
        runcmd_at(name, `scriptevent fearcube:setLobby`, true);
        return;
    }
    if (typeId === "fear:viewer") {
        if (player.hasTag(`fear:lobby`)) {}
        playerWatch(player)
        return;
    }
    if (typeId === "fear:map_information") {
        informationMain(player)
        return;
    }
    if (typeId === "fear:playgame") {
        const lockjoin = getScore('fear:settings', 'lockjoin', true);
        if (lockjoin === 0) {
            if (!player.hasTag(`fear:lobby`)) {
                toLobby(player);
            }
        } else {
            Tellraw(player, `§c`, "fearcube.message.join_blocked", " §6\\lockjoin");
            runcmd_at(name, `playanimation @s animation.n.start_button.interact`, true);
        }
        return;
    }
}




