import { world, system } from "@minecraft/server";
import { 
    getScore, eventEntity,
    getPlayerCountWithTag, 
    playSound, Tellraw, 
    ActionBar, cloceUI,
    removeTagsByPrefix, 
    getPlayerNamesWithTag, 
    ReplaceItemHotbar, 
    getHealthPercentage, 
    ReplaceItem, getPlayerByName,
    hasItemInInventory,
    incrementScore,
    modifyScore,
    getRandomInRange,
    cloceForm

} from './other/utils';
import {startTimer} from './lobby/timer'
import {timerPurchase} from './game/purchaseTimer'
import {startTimerSpecialForces} from './game/special_forces_timer'
import {startTimerExplode} from './game/explodeTimer'

export function restarterMap () {
    const restarter_map = getScore('fear:settings', 'restarter_map', true);
    const lobby_timer = getScore('fear:settings', 'lobby_timer', true);

    if (restarter_map === 0) {
        for (const player of world.getPlayers()) {
            cloceUI(player);
        }
    }

    if (restarter_map === 1) {
        if (lobby_timer >= 1) {
            startLobbyRestarter()
        }
    }

    if (restarter_map === 2) {
        timerPurchase()
    }

    if (restarter_map === 3) {
        startTimerSpecialForces()
    }

    if (restarter_map === 4) {
        startTimerExplode()
    }
}


export function startLobbyRestarter() {
    const lobby_timer = getScore('fear:settings', 'lobby_timer', true);
    startTimer(lobby_timer);
}